proc shpat_# {str pat} {
	set s $str
	set result ""
	while 1 {
	   if {! [regexp "^$pat" $str result]} {
		return [string range $s [string length $result] end]
	   }
	   set str [string range $result 0 [expr [string length $result] - 2]]
	}
}

proc shpat_## {str pat} {
	if {[regexp "^$pat" $str result]} {
		return [string range $str [string length $result] end]
	} else {
		return $str
	}
}

proc shpat_% {str pat} {
	set s $str
	set result ""
	while 1 {
	   if {! [regexp "$pat\$" $str result]} {
		return [string range $s 0 [expr [string length $s] - \
			[string length $result] -1]]
	   }
	   if {$result == ""} {return $result}
	   set str [string range $result 1 [expr [string length $result] - 1]]
	}
}

proc shpat_%% {str pat} {
	if {[regexp "$pat\$" $str result]} {
		return [string range $str 0 [expr [string length $str] - \
			[string length $result] -1]]
	} else {
		return $str
	}
}

proc sh_vnull {varname} {
	upvar $varname v
	if {[catch {set v}]} {
		return 1
	} {
		if {$v == ""} {
			return 1
		}
	}
	return 0
}
